﻿using System;
using System.Windows;

namespace RssReader.Helpers
{
    public class DialogService : IDialogService
    {
        public void ShowError(string errorMessage, string title, string buttonText)
        {
            MessageBox.Show(errorMessage, title, MessageBoxButton.OK);
        }

        public void ShowError(Exception error, string title, string buttonText)
        {
            MessageBox.Show(error.Message, title, MessageBoxButton.OK);
        }

        public void ShowMessage(string message, string title, string buttonText)
        {
            // The Windows Phone implementation of MessageBox doesn't allow
            // setting the text for the button. Please do not use MessageBox
            // in a production project! Instead implement a custom
            // message box!
            MessageBox.Show(message, title, MessageBoxButton.OK);
        }
    }
}