﻿using System;
using System.Net;
using System.Threading.Tasks;

namespace RssReader.Model
{
    public class Downloader
    {
        public Task<string> GetRssFeed(string feedUrl)
        {
            var tcs = new TaskCompletionSource<string>();

            var client = new WebClient();
            client.DownloadStringCompleted += (s, e) =>
            {
                if (e.Error == null)
                {
                    tcs.SetResult(e.Result);
                }
                else
                {
                    tcs.TrySetException(e.Error);
                }
            };

            client.DownloadStringAsync(new Uri(feedUrl));

            return tcs.Task;
        }
    }
}